/******************************************************/
/*         CryptoXor v1.0 by Jeb(@jeb.com.fr)         */
/*                                                    */
/*                                                    */
/*     To compile type:                               */
/*          cc -O2 cryptoxor.c -o cryptoxor           */
/*       or make                                      */
/*                                                    */
/*     Look insite README for more information        */
/*                                                    */
/******************************************************/

#include <stdio.h>

int main(int argc, char **argv) {
FILE           *In, *Out, *Key;
unsigned char   byte, bytekey;

        if (argc != 4) {
                printf("Usage: %s <source_file> <key_file> <destionation_file>\n", argv[0]);
                exit(0);
        }

        if ((In = fopen(argv[1], "rb+")) == NULL) {
                printf("Where is %s file ? deleted ?\n", argv[1]);
                exit(-1);
        }

        if ((Key = fopen(argv[2], "rb+")) == NULL) {
                printf("Where is %s key ? deleted ?\n", argv[2]);
                fclose(In);
                exit(-1);
        }

        if ((Out = fopen(argv[3], "wb+")) == NULL) {
                printf("Can't create %s\n", argv[3]);
                fclose(In);
                fclose(Key);
                exit (-1);
        }

        while (fread(&byte, 1, 1, In)) {
                if (feof(Key) != NULL) rewind(Key);
                fread(&bytekey, 1, 1, Key);
                byte ^= bytekey;  // same as  byte = byte ^ bytekey
                fwrite(&byte, 1, 1, Out);
        }

fclose(In);
fclose(Out);
fclose(Key);
return 0;

}
